import{s as Fe,f as Se,n as Ye,o as qe}from"../chunks/scheduler.63274e7e.js";import{S as ze,i as Be,g as s,s as i,r as u,A as Ge,h as o,f as n,c as a,j as De,u as g,x as r,k as z,y as Oe,a as l,v as p,d as f,t as d,w as h}from"../chunks/index.bf3f3f8e.js";import{H as q,E as Ve}from"../chunks/EditOnGithub.7d836abf.js";function Ne($e){let m,O,B,V,c,N,v,we='In this game, we want to run a sentence similarity model, I’m going to use <a href="https://huggingface.co/sentence-transformers/all-MiniLM-L6-v2" rel="nofollow">all-MiniLM-L6-v2</a>.',J,y,Te="It’s a BERT Transformer model. It’s <strong>already trained so we can use it directly.</strong>",K,$,_e="But here, I have two solutions to run it, I can:",Q,w,Le="<li><em>Run this AI model remotely</em>: <strong>on a server</strong>. I send API calls and get responses from the server. That requires an internet connection.</li> <li><em>Run this AI model locally</em>: <strong>on the player’s machine.</strong></li>",W,T,Me="Both are valid solutions, <strong>but they have advantages and disadvantages</strong>.",X,_,Z,L,Ie="I run the model <strong>on a remote server</strong>, and send API calls from the game. I can use an API service to help deploy the model.",ee,M,He,te,I,xe='For instance, Hugging Face provides an API service called <a href="https://huggingface.co/inference-api" rel="nofollow">Inference API</a> (free for prototyping and experimentation) that allows you to use AI models via simple API calls. And we have a <a href="https://huggingface.co/blog/unity-api" rel="nofollow">Unity plugin</a> to access and use Hugging Face AI models from within Unity projects.',ne,H,le,x,Ae="<li>You’re not using the RAM/VRAM of your player to run the model.</li> <li>Your server can log the data, so you can understand what actions players usually type and thus you can improve your NPC.</li>",ie,A,ae,P,Pe="<li><strong>Dependence on an internet connection</strong>, risking immersion disruption due to potential API lag.</li> <li><strong>Potential high cost associated with API usage</strong>, especially with many players.</li>",se,C,Ce="Usually, you use an API if you use a very big model that couldn’t run on a player machine. For instance if you use big models like Llama 2.",oe,b,re,R,be="I run the model locally: on the player machine. To be able to do that I use two libraries.",me,U,Re='<li><p><a href="https://docs.unity3d.com/Packages/com.unity.sentis@latest" rel="nofollow">Unity Sentis</a>: the neural network inference library that allow us to run our AI model directly inside our game.</p></li> <li><p><a href="https://github.com/huggingface/sharp-transformers" rel="nofollow">The Hugging Face Sharp Transformers library</a>: a Unity plugin of utilities to run Transformer 🤗 models in Unity games.</p></li>',ue,k,Ue,ge,E,pe,j,ke="<li>You don’t have usage cost since everything runs on the player’s computer.</li> <li>The player does not need to be connected to the Internet.</li>",fe,S,de,D,Ee="<li>You use the RAM/VRAM of the player so you need to specify spec recommendations</li> <li>You can’t easily know how people use the game or the model.</li>",he,F,je="Since the sentence similarity model we’re going to use is small, <strong>we decided to run it locally</strong>.",ce,Y,ve,G,ye;return c=new q({props:{title:"How to run an AI model: local vs remote",local:"how-to-run-an-ai-model-local-vs-remote",headingTag:"h1"}}),_=new q({props:{title:"Running the model remotely",local:"running-the-model-remotely",headingTag:"h2"}}),H=new q({props:{title:"Advantages",local:"advantages",headingTag:"h2"}}),A=new q({props:{title:"Disadvantages",local:"disadvantages",headingTag:"h2"}}),b=new q({props:{title:"Running the model locally",local:"running-the-model-locally",headingTag:"h2"}}),E=new q({props:{title:"Advantages",local:"advantages",headingTag:"h3"}}),S=new q({props:{title:"Disadvantages",local:"disadvantages",headingTag:"h3"}}),Y=new Ve({props:{source:"https://github.com/huggingface/making-games-with-ai-course/blob/main/units/en/unit1/local-vs-api.mdx"}}),{c(){m=s("meta"),O=i(),B=s("p"),V=i(),u(c.$$.fragment),N=i(),v=s("p"),v.innerHTML=we,J=i(),y=s("p"),y.innerHTML=Te,K=i(),$=s("p"),$.textContent=_e,Q=i(),w=s("ul"),w.innerHTML=Le,W=i(),T=s("p"),T.innerHTML=Me,X=i(),u(_.$$.fragment),Z=i(),L=s("p"),L.innerHTML=Ie,ee=i(),M=s("img"),te=i(),I=s("p"),I.innerHTML=xe,ne=i(),u(H.$$.fragment),le=i(),x=s("ul"),x.innerHTML=Ae,ie=i(),u(A.$$.fragment),ae=i(),P=s("ul"),P.innerHTML=Pe,se=i(),C=s("p"),C.textContent=Ce,oe=i(),u(b.$$.fragment),re=i(),R=s("p"),R.textContent=be,me=i(),U=s("ol"),U.innerHTML=Re,ue=i(),k=s("img"),ge=i(),u(E.$$.fragment),pe=i(),j=s("ul"),j.innerHTML=ke,fe=i(),u(S.$$.fragment),de=i(),D=s("ul"),D.innerHTML=Ee,he=i(),F=s("p"),F.innerHTML=je,ce=i(),u(Y.$$.fragment),ve=i(),G=s("p"),this.h()},l(e){const t=Ge("svelte-u9bgzb",document.head);m=o(t,"META",{name:!0,content:!0}),t.forEach(n),O=a(e),B=o(e,"P",{}),De(B).forEach(n),V=a(e),g(c.$$.fragment,e),N=a(e),v=o(e,"P",{"data-svelte-h":!0}),r(v)!=="svelte-iyzv6a"&&(v.innerHTML=we),J=a(e),y=o(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-tfnlma"&&(y.innerHTML=Te),K=a(e),$=o(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-3w5216"&&($.textContent=_e),Q=a(e),w=o(e,"UL",{"data-svelte-h":!0}),r(w)!=="svelte-1mnrhrg"&&(w.innerHTML=Le),W=a(e),T=o(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-64mdo2"&&(T.innerHTML=Me),X=a(e),g(_.$$.fragment,e),Z=a(e),L=o(e,"P",{"data-svelte-h":!0}),r(L)!=="svelte-wh55ai"&&(L.innerHTML=Ie),ee=a(e),M=o(e,"IMG",{src:!0,alt:!0}),te=a(e),I=o(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-xpvy17"&&(I.innerHTML=xe),ne=a(e),g(H.$$.fragment,e),le=a(e),x=o(e,"UL",{"data-svelte-h":!0}),r(x)!=="svelte-krhajt"&&(x.innerHTML=Ae),ie=a(e),g(A.$$.fragment,e),ae=a(e),P=o(e,"UL",{"data-svelte-h":!0}),r(P)!=="svelte-kmhnz0"&&(P.innerHTML=Pe),se=a(e),C=o(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-n1obm"&&(C.textContent=Ce),oe=a(e),g(b.$$.fragment,e),re=a(e),R=o(e,"P",{"data-svelte-h":!0}),r(R)!=="svelte-1tp0rms"&&(R.textContent=be),me=a(e),U=o(e,"OL",{"data-svelte-h":!0}),r(U)!=="svelte-1rpw1li"&&(U.innerHTML=Re),ue=a(e),k=o(e,"IMG",{src:!0,alt:!0}),ge=a(e),g(E.$$.fragment,e),pe=a(e),j=o(e,"UL",{"data-svelte-h":!0}),r(j)!=="svelte-4rjpqe"&&(j.innerHTML=ke),fe=a(e),g(S.$$.fragment,e),de=a(e),D=o(e,"UL",{"data-svelte-h":!0}),r(D)!=="svelte-86x825"&&(D.innerHTML=Ee),he=a(e),F=o(e,"P",{"data-svelte-h":!0}),r(F)!=="svelte-1dynhkd"&&(F.innerHTML=je),ce=a(e),g(Y.$$.fragment,e),ve=a(e),G=o(e,"P",{}),De(G).forEach(n),this.h()},h(){z(m,"name","hf:doc:metadata"),z(m,"content",Je),Se(M.src,He="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/remote.jpg")||z(M,"src",He),z(M,"alt","Running AI model remotely"),Se(k.src,Ue="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/local.jpg")||z(k,"src",Ue),z(k,"alt","Running AI model locally")},m(e,t){Oe(document.head,m),l(e,O,t),l(e,B,t),l(e,V,t),p(c,e,t),l(e,N,t),l(e,v,t),l(e,J,t),l(e,y,t),l(e,K,t),l(e,$,t),l(e,Q,t),l(e,w,t),l(e,W,t),l(e,T,t),l(e,X,t),p(_,e,t),l(e,Z,t),l(e,L,t),l(e,ee,t),l(e,M,t),l(e,te,t),l(e,I,t),l(e,ne,t),p(H,e,t),l(e,le,t),l(e,x,t),l(e,ie,t),p(A,e,t),l(e,ae,t),l(e,P,t),l(e,se,t),l(e,C,t),l(e,oe,t),p(b,e,t),l(e,re,t),l(e,R,t),l(e,me,t),l(e,U,t),l(e,ue,t),l(e,k,t),l(e,ge,t),p(E,e,t),l(e,pe,t),l(e,j,t),l(e,fe,t),p(S,e,t),l(e,de,t),l(e,D,t),l(e,he,t),l(e,F,t),l(e,ce,t),p(Y,e,t),l(e,ve,t),l(e,G,t),ye=!0},p:Ye,i(e){ye||(f(c.$$.fragment,e),f(_.$$.fragment,e),f(H.$$.fragment,e),f(A.$$.fragment,e),f(b.$$.fragment,e),f(E.$$.fragment,e),f(S.$$.fragment,e),f(Y.$$.fragment,e),ye=!0)},o(e){d(c.$$.fragment,e),d(_.$$.fragment,e),d(H.$$.fragment,e),d(A.$$.fragment,e),d(b.$$.fragment,e),d(E.$$.fragment,e),d(S.$$.fragment,e),d(Y.$$.fragment,e),ye=!1},d(e){e&&(n(O),n(B),n(V),n(N),n(v),n(J),n(y),n(K),n($),n(Q),n(w),n(W),n(T),n(X),n(Z),n(L),n(ee),n(M),n(te),n(I),n(ne),n(le),n(x),n(ie),n(ae),n(P),n(se),n(C),n(oe),n(re),n(R),n(me),n(U),n(ue),n(k),n(ge),n(pe),n(j),n(fe),n(de),n(D),n(he),n(F),n(ce),n(ve),n(G)),n(m),h(c,e),h(_,e),h(H,e),h(A,e),h(b,e),h(E,e),h(S,e),h(Y,e)}}}const Je='{"title":"How to run an AI model: local vs remote","local":"how-to-run-an-ai-model-local-vs-remote","sections":[{"title":"Running the model remotely","local":"running-the-model-remotely","sections":[],"depth":2},{"title":"Advantages","local":"advantages","sections":[],"depth":2},{"title":"Disadvantages","local":"disadvantages","sections":[],"depth":2},{"title":"Running the model locally","local":"running-the-model-locally","sections":[{"title":"Advantages","local":"advantages","sections":[],"depth":3},{"title":"Disadvantages","local":"disadvantages","sections":[],"depth":3}],"depth":2}],"depth":1}';function Ke($e){return qe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ze extends ze{constructor(m){super(),Be(this,m,Ke,Ne,Fe,{})}}export{Ze as component};
